Option Strict On
Option Explicit On

Imports System.Runtime.InteropServices
Imports System.Text


Module mmgic3az
    '//
    '//// mmgic3az.dll  Header Ver3.1305a
    '//
    '//   (C) m.magic & K Maruyama.  All rights reserved.

    '//
    '//// 
    '//

    '// 萔
    Public Const MAZ_NULL As Integer = 0
    Public Const MAZ_MAX_PATH As Integer = 259
    Public Const MAZ_YES As Integer = 1
    Public Const MAZ_NO As Integer = 0
    Public Const MAZ_OK As Integer = 1
    Public Const MAZ_CANCEL As Integer = 0
    '// ߂l
    Public Const MAZ_SUCCESS As Integer = 0
    Public Const MAZ_FAILURE As Integer = -1
    Public Const MAZ_TRUE As Integer = 1
    Public Const MAZ_FALSE As Integer = 0
    '// ^
    Public Structure MAZ_RECT
        Dim left As Integer
        Dim top As Integer
        Dim right As Integer
        Dim bottom As Integer
    End Structure

    '//
    '////  fBXN
    '//
    '//* mazGetDriveType *//
    '// 萔
    Public Const MAZ_DRIVE_UNKNOWN As Integer = 0       '//The drive type cannot be determined.
    Public Const MAZ_DRIVE_NO_ROOT_DIR As Integer = 1   '//The root path is invalid. For example, no volume is mounted at the path.
    Public Const MAZ_DRIVE_REMOVABLE As Integer = 2     '//The disk can be removed from the drive.
    Public Const MAZ_DRIVE_FIXED As Integer = 3         '//The disk cannot be removed from the drive.
    Public Const MAZ_DRIVE_REMOTE As Integer = 4        '//The drive is a remote (network) drive.
    Public Const MAZ_DRIVE_CDROM As Integer = 5         '//The drive is a CD-ROM drive.
    Public Const MAZ_DRIVE_RAMDISK As Integer = 6       '//The drive is a RAM disk.
    '//* mazGetLogicalDrives *//
    Public Const MAZ_DRIVE_A As Integer = &H1
    Public Const MAZ_DRIVE_B As Integer = &H2
    Public Const MAZ_DRIVE_C As Integer = &H4
    Public Const MAZ_DRIVE_D As Integer = &H8
    Public Const MAZ_DRIVE_E As Integer = &H10
    Public Const MAZ_DRIVE_F As Integer = &H20
    Public Const MAZ_DRIVE_G As Integer = &H40
    Public Const MAZ_DRIVE_H As Integer = &H80
    Public Const MAZ_DRIVE_I As Integer = &H100
    Public Const MAZ_DRIVE_J As Integer = &H200
    Public Const MAZ_DRIVE_K As Integer = &H400
    Public Const MAZ_DRIVE_L As Integer = &H800
    Public Const MAZ_DRIVE_M As Integer = &H1000
    Public Const MAZ_DRIVE_N As Integer = &H2000
    Public Const MAZ_DRIVE_O As Integer = &H4000
    Public Const MAZ_DRIVE_P As Integer = &H8000
    Public Const MAZ_DRIVE_Q As Integer = &H10000
    Public Const MAZ_DRIVE_R As Integer = &H20000
    Public Const MAZ_DRIVE_S As Integer = &H40000
    Public Const MAZ_DRIVE_T As Integer = &H80000
    Public Const MAZ_DRIVE_U As Integer = &H100000
    Public Const MAZ_DRIVE_V As Integer = &H200000
    Public Const MAZ_DRIVE_W As Integer = &H400000
    Public Const MAZ_DRIVE_X As Integer = &H800000
    Public Const MAZ_DRIVE_Y As Integer = &H1000000
    Public Const MAZ_DRIVE_Z As Integer = &H2000000
    '//* mazGetVolumeInformation *//
    '// 萔
    Public Const MAZ_GVI_CASE_IS_PRESERVED As Integer = &H2         '// t@CL^ƂɁA啶Əʂĕۑ܂B
    Public Const MAZ_GVI_CASE_SENSITIVE As Integer = &H1            '// t@C̑啶Ə̋ʂT|[gĂ܂B
    Public Const MAZ_GVI_UNICODE_STORED_ON_DISK As Integer = &H4    '// Unicode ̃t@CT|[gĂāAfBXNł\܂B
    Public Const MAZ_GVI_PERSISTENT_ACLS As Integer = &H8           '// ACLiANZX䃊Xgj̕ۑƓKps܂B
    Public Const MAZ_GVI_FILE_COMPRESSION As Integer = &H10         '// t@Cx[ẌkT|[gĂ܂B
    Public Const MAZ_GVI_VOL_IS_COMPRESSED As Integer = &H8000      '// k{[łB
    Public Const MAZ_GVI_NAMED_STREAMS As Integer = &H40000         '// OtXg[T|[gĂ܂B
    Public Const MAZ_GVI_SUPPORTS_ENCRYPTION As Integer = &H20000   '// Ít@CVXeiEFSjT|[gĂ܂B
    Public Const MAZ_GVI_SUPPORTS_OBJECT_IDS As Integer = &H10000   '// IuWFNgʎqT|[gĂ܂B
    Public Const MAZ_GVI_SUPPORTS_REPARSE_POINTS As Integer = &H80  '// ĉ̓|CgT|[gĂ܂B
    Public Const MAZ_GVI_SUPPORTS_SPARSE_FILES As Integer = &H40    '// aȃt@CAgp̗̈悪A܂͓lt@CT|[gĂ܂B
    Public Const MAZ_GVI_VOLUME_QUOTAS As Integer = &H20            '// fBXNNH[^T|[gĂ܂B
    '// ^
    Structure MAZ_GVI_VOLUME_INFORMATION
        <VBFixedString(255), MarshalAs(UnmanagedType.ByValTStr, SizeConst:=256)> _
        Dim volumeName As String
        Dim volumeSerialNumber As Integer
        Dim maximumComponentLength As Integer
        Dim fileSystemFlags As Integer
        <VBFixedString(255), MarshalAs(UnmanagedType.ByValTStr, SizeConst:=256)> _
        Dim systemName As String
    End Structure


    '//
    '//// t@C
    '//
    '//* mazGetFileVersionEx *//
    '// 
    Public Const MAZ_GFV_FILE_VERSION_SIZE As Integer = 280
    '// ^
    Structure MAZ_GFV_FILE_VERSION
        Public major As Integer
        Public minor As Integer
        Public revision As Integer
        Public bild As Integer
        Public length As Integer      '// filePath ̃TCY	
        <VBFixedString(MAZ_MAX_PATH), MarshalAs(UnmanagedType.ByValTStr, SizeConst:=MAZ_MAX_PATH + 1)> _
        Public filePath As String     '// lo[W̃t@CpX
        Public Sub initialize()
            major = 0
            minor = 0
            revision = 0
            bild = 0
            length = 0
            filePath = New String(Chr(Asc(" ")), MAZ_MAX_PATH)
        End Sub
    End Structure

    '//* mazShowDirListBox *//
    '// 
    Public Const MAZ_SDB_TYPE_A As Integer = &H1003
    Public Const MAZ_SDB_TYPE_B As Integer = &H1243
    Public Const MAZ_SDB_TYPE_C As Integer = &H1043
    '// ^
    Public Structure MAZ_SDB_INFORMATION
        Dim wnd As IntPtr
        Dim style As Integer
        Dim x As Integer
        Dim y As Integer
        Dim width As Integer
        Dim height As Integer
        Dim message As String
        Dim currentDirectory As String
        Dim reserved As Integer
    End Structure
    '//* mazGetSpecialFolderPath  *//
    '// 萔
    Public Const MAZ_SFP_ADMINTOOLS As Integer = &H30
    Public Const MAZ_SFP_APPDATA As Integer = &H1A
    Public Const MAZ_SFP_ADMINTOOLS_A As Integer = &H30
    Public Const MAZ_SFP_COMMON_APPDATA As Integer = &H23
    Public Const MAZ_SFP_COMMON_DESKTOPDIRECTORY As Integer = &H19
    Public Const MAZ_SFP_COMMON_DOCUMENTS As Integer = &H2E
    Public Const MAZ_SFP_COMMON_FAVORITES As Integer = &H1F
    Public Const MAZ_SFP_COMMON_MUSIC As Integer = &H35
    Public Const MAZ_SFP_COMMON_PICTURES As Integer = &H36
    Public Const MAZ_SFP_COMMON_PROGRAMS As Integer = &H17
    Public Const MAZ_SFP_COMMON_STARTMENU As Integer = &H16
    Public Const MAZ_SFP_COMMON_STARTUP As Integer = &H18
    Public Const MAZ_SFP_COMMON_TEMPLATES As Integer = &H2D
    Public Const MAZ_SFP_COOKIES As Integer = &H21
    Public Const MAZ_SFP_DESKTOP As Integer = &H0
    Public Const MAZ_SFP_DESKTOPDIRECTORY As Integer = &H10
    Public Const MAZ_SFP_FAVORITES As Integer = &H6
    Public Const MAZ_SFP_FONTS As Integer = &H14
    Public Const MAZ_SFP_HISTORY As Integer = &H22
    Public Const MAZ_SFP_INTERNET_CACHE As Integer = &H20
    Public Const MAZ_SFP_LOCAL_APPDATA As Integer = &H1C
    Public Const MAZ_SFP_MYMUSIC As Integer = &HD
    Public Const MAZ_SFP_MYPICTURES As Integer = &H27
    Public Const MAZ_SFP_MYVIDEO As Integer = &HE
    Public Const MAZ_SFP_PERSONAL As Integer = &H5
    Public Const MAZ_SFP_PROGRAM_FILES As Integer = &H26
    Public Const MAZ_SFP_PROGRAM_FILES_COMMON As Integer = &H2B
    Public Const MAZ_SFP_PROGRAMS As Integer = &H2
    Public Const MAZ_SFP_RECENT As Integer = &H8
    Public Const MAZ_SFP_STARTMENU As Integer = &HB
    Public Const MAZ_SFP_STARTUP As Integer = &H7
    Public Const MAZ_SFP_SYSTEM_A As Integer = &H25
    Public Const MAZ_SFP_TEMPLATES As Integer = &H15
    Public Const MAZ_SFP_WINDOWS As Integer = &H24
    '//* mazGetFileAttributes & mazSetFileAttributes *//
    '// 萔
    Public Const MAZ_ATR_ARCHIVE As Integer = &H20          '// A[JCut@C܂̓A[JCufBNgłB
    Public Const MAZ_ATR_COMPRESSED As Integer = &H800      '// t@C܂̓fBNg͈kĂ܂B
    Public Const MAZ_ATR_DEVICE As Integer = &H40           '// \ς݁BgȂłB
    Public Const MAZ_ATR_DIRECTORY As Integer = &H20        '// fBNgB
    Public Const MAZ_ATR_ENCRYPTED As Integer = &H4000      '// t@C܂̓fBNg͈ÍĂ܂B
    Public Const MAZ_ATR_HIDDEN As Integer = &H2            '// Bt@C܂͉BfBNgłB
    Public Const MAZ_ATR_NORMAL As Integer = &H80           '// t@C܂̓fBNgɂ́Aɑ͂܂B
    Public Const MAZ_ATR_NOT_CONTENT_INDEXED As Integer = &H2000 '// Windows 2000FCfbNXT[rX̑ΏۂɂȂĂ܂B
    Public Const MAZ_ATR_OFFLINE As Integer = &H1000        '// Windows 2000F̃t@C̃f[^́Aɂ͗pł܂B
    Public Const MAZ_ATR_READONLY As Integer = &H1          '// t@C܂̓fBNg͓ǂݎpłB
    Public Const MAZ_ATR_REPARSE_POINT As Integer = &H400   '// ĉ̓|Cg֘AtĂ܂B
    Public Const MAZ_ATR_SPARSE_FILE As Integer = &H200     '// aȃt@CAgp̗̈悪A܂͓lt@CłB
    Public Const MAZ_ATR_SYSTEM As Integer = &H4            '// t@C܂̓fBNǵAIy[eBOVXepłB
    Public Const MAZ_ATR_TEMPORARY As Integer = &H100
    '//* mazGetWindowsPath *//
    '// 
    Public Const MAZ_GWP_WINDOWS_PATH As Integer = 1
    Public Const MAZ_GWP_SYSTEM_PATH As Integer = 2
    '//* mazGetFileTime & mazSetFileTime *//
    '// 
    Public Const MAZ_FTM_TIME_KIND As Integer = &HFF
    Public Const MAZ_FTM_CREATE_TIME As Integer = &H1
    Public Const MAZ_FTM_ACCESS_TIME As Integer = &H2
    Public Const MAZ_FTM_WRITE_TIME As Integer = &H4
    '// ^
    Public Structure MAZ_SYSTEMTIME
        Dim year As Short
        Dim month As Short
        Dim dayOfWeek As Short
        Dim day As Short
        Dim hour As Short
        Dim minute As Short
        Dim second As Short
        Dim milliseconds As Short
    End Structure
    '//* mazSearchDirectory *//
    '// 
    Public Const MAZ_SDR_SEARCH_OPTIONS As Integer = &HFF
    Public Const MAZ_SDR_SEARCH As Integer = &H0
    Public Const MAZ_SDR_NO_SUBDIR As Integer = &H0
    Public Const MAZ_SDR_INCLUDE_SUBDIR As Integer = &H1
    Public Const MAZ_SDR_NO_DIR_NAME As Integer = &H0
    Public Const MAZ_SDR_INCLUDE_DIR_NAME As Integer = &H2
    Public Const MAZ_SDR_ATTRIBUTES_TYPE As Integer = &HFF00
    Public Const MAZ_SDR_NORMAL_ATTRIBUTES As Integer = &H0
    Public Const MAZ_SDR_INCLUDE_ARCHIVE As Integer = &H100
    Public Const MAZ_SDR_INCLUDE_HIDDEN As Integer = &H200
    Public Const MAZ_SDR_INCLUDE_READONLY As Integer = &H400
    Public Const MAZ_SDR_INCLUDE_SYSTEM As Integer = &H800
    '// ߂l
    Public Const MAZ_SDR_ERR_FILE As Integer = -200
    Public Const MAZ_SDR_ERR_CANCEL As Integer = -201
    '// R[obN֐
    Public Const MAZ_SDR_BEGINE_PROCESS As Integer = 0
    Public Const MAZ_SDR_END_PROCESS As Integer = -1000000
    '// ^
    Public Structure MAZ_SDR_DIRECTORY_SEARCH
        Dim process As DirectorySearchAZ      'R[obN֐̃|C^
        Dim parameters As SDR_FREE_PARAMETERS 'ėp|C^ĩ|C^́AR[obN֐ɂ̂܂ܓnj
    End Structure


    '//
    '//// WXg
    '//
    '//* mazSetRegData & mazGetRegData *//
    '// 
    '// function
    Public Const MAZ_REG_READ As Integer = 2
    Public Const MAZ_REG_READ_SIZE As Integer = 3
    '// key
    Public Const MAZ_REG_ROOT As Integer = 1
    Public Const MAZ_REG_CURRENT_CONFIG As Integer = 2
    Public Const MAZ_REG_CURRENT_USER As Integer = 3
    Public Const MAZ_REG_LOCAL_MACHINE As Integer = 4
    Public Const MAZ_REG_USER As Integer = 5
    Public Const MAZ_REG_DYN_DATA As Integer = 6
    Public Const MAZ_REG_PERFORMANCE_DATA As Integer = 7
    Public Const MAZ_REG_PERFORMANCE_NLSTEXT As Integer = 8
    Public Const MAZ_REG_PERFORMANCE_TEXT As Integer = 9
    '// type
    Public Const MAZ_REG_SZ As Integer = 1
    Public Const MAZ_REG_BINARY As Integer = 3
    Public Const MAZ_REG_REG_DWORD As Integer = 4
    Public Const MAZ_REG_REG_QWORD As Integer = 11


    '//
    '//// VXe
    '//
    '//* mazGetWinVersion *//
    Public Const MAZ_GWV_PLATFORM_WIN32s As Integer = 0         '// Win32s on Windows 3.1. 
    Public Const MAZ_GWV_PLATFORM_WIN32_WINDOWS As Integer = 1  '// Windows 95, Windows 98, or Windows Me. 
    Public Const MAZ_GWV_PLATFORM_WIN32_NT As Integer = 1
    '// ^
    Public Structure MAZ_GWV_OSVERSIONINFO
        Dim osSVersionInfoSize As Integer
        Dim majorVersion As Integer
        Dim minorVersion As Integer
        Dim buildNumber As Integer
        Dim platformId As Integer
        <VBFixedString(127), MarshalAs(UnmanagedType.ByValTStr, SizeConst:=128)> _
        Public csdVersion As String   '  Maintenance string for PSS usage
    End Structure
    '//* mazGetMemoryStatus *//
    Public Structure MAZ_MEMORYSTATUSEX
        Dim length As Integer
        Dim memoryLoad As Integer
        Dim totalPhys As Long
        Dim availPhys As Long
        Dim totalPageFile As Long
        Dim availPageFile As Long
        Dim totalVirtual As Long
        Dim availVirtual As Long
        Dim availExtendedVirtual As Long
    End Structure
    '//* mazGetCpuInformations *//
    '// 
    Public Const MAZ_GCI_DO_NOT_WRITE_TO_FILE As Integer = MAZ_NULL
    Public Const MAZ_GCI_MAX_VNAME_LEN As Integer = 14 - 1
    Public Const MAZ_GCI_MAX_MNAME_LEN As Integer = 50 - 1
    Public Const MAZ_GCI_MAX_STANDERD_COUNT As Integer = 64 - 1
    Public Const MAZ_GCI_MAX_EXTENDED_COUNT As Integer = 64 - 1
    '// register
    Public Const MAZ_GCI_EAX As Integer = 0
    Public Const MAZ_GCI_EBX As Integer = 1
    Public Const MAZ_GCI_ECX As Integer = 2
    Public Const MAZ_GCI_EDX As Integer = 3
    '// 3d commands
    Public Const MAZ_GCI_FEATURE_MMX As Integer = &H100
    Public Const MAZ_GCI_FEATURE_MMX_EXT As Integer = &H200
    Public Const MAZ_GCI_FEATURE_SSE As Integer = &H400
    Public Const MAZ_GCI_FEATURE_SSE2 As Integer = &H800
    Public Const MAZ_GCI_FEATURE_SSE3 As Integer = &H1000
    Public Const MAZ_GCI_FEATURE_SSE4_1 As Integer = &H2000
    Public Const MAZ_GCI_FEATURE_SSE4_2 As Integer = &H4000
    Public Const MAZ_GCI_FEATURE_3DNOW As Integer = &H1
    Public Const MAZ_GCI_FEATURE_3DNOW_EXT As Integer = &H2
    Public Const MAZ_GCI_FEATURE_SSE4_A As Integer = &H4
    '// Virtual Machine
    Public Const MAZ_GCI_FEATURE_AMD_V As Integer = &H10000
    Public Const MAZ_GCI_FEATURE_INTEL_VT As Integer = &H20000
    '// 64-bit technology available 
    Public Const MAZ_GCI_FEATURE_X64 As Integer = &H40000
    '// ߂l
    Public Const MAZ_GCI_ERR_NOT_SUPPORTED As Integer = 1
    Public Const MAZ_GCI_ERR_FILE As Integer = -10000
    Public Const MAZ_GCI_ERR_OUTPUT_BUFFER As Integer = -10001
    '// ^
    'VB.NET 2008 p MAZ_GCI_INFORMATION_A (VB.NET 2005 ȍ~ŎgpH) -->
    'Public Structure MAZ_GCI_CPUID
    '<VBFixedArray(3), MarshalAs(UnmanagedType.ByValArray, SizeConst:=4)> _
    'Dim value() As Integer
    'Public Sub initialize()
    '    ReDim value(3)
    'End Sub
    'End Structure

    'Public Structure MAZ_GCI_INFORMATION_A
    'Dim size As Integer            '// size of this structure
    '<VBFixedArray(MAZ_GCI_MAX_STANDERD_COUNT), _
    'MarshalAs(UnmanagedType.ByValArray, SizeConst:=MAZ_GCI_MAX_STANDERD_COUNT + 1)> _
    'Dim standard() As MAZ_GCI_CPUID
    '<VBFixedArray(MAZ_GCI_MAX_EXTENDED_COUNT), _
    'MarshalAs(UnmanagedType.ByValArray, SizeConst:=MAZ_GCI_MAX_EXTENDED_COUNT + 1)> _
    'Dim extended() As MAZ_GCI_CPUID
    'Public Sub initialize()
    'size = 2052
    'Dim i As Integer
    'ReDim standard(MAZ_GCI_MAX_STANDERD_COUNT)
    'For i = 0 To MAZ_GCI_MAX_STANDERD_COUNT
    'standard(i).initialize()
    'Next
    'ReDim extended(MAZ_GCI_MAX_EXTENDED_COUNT)
    'For i = 0 To MAZ_GCI_MAX_EXTENDED_COUNT
    'extended(i).initialize()
    'Next
    'End Sub
    'End Structure
    '<-- VB.NET 2008 p

    'VB.NET 2003 p MAZ_GCI_INFORMATION_A -->
    Public Structure MAZ_GCI_INFORMATION_A
        Dim size As Integer            '// size of this structure
        <VBFixedArray((MAZ_GCI_MAX_STANDERD_COUNT + 1) * 4 - 1), _
        MarshalAs(UnmanagedType.ByValArray, SizeConst:=(MAZ_GCI_MAX_STANDERD_COUNT + 1) * 4)> _
        Dim cidStandard() As Integer
        <VBFixedArray((MAZ_GCI_MAX_EXTENDED_COUNT + 1) * 4 - 1), _
        MarshalAs(UnmanagedType.ByValArray, SizeConst:=(MAZ_GCI_MAX_EXTENDED_COUNT + 1) * 4)> _
        Dim cidExtended() As Integer
        Sub initialize()
            size = 2052
            ReDim cidStandard((MAZ_GCI_MAX_STANDERD_COUNT + 1) * 4 - 1)
            ReDim cidExtended((MAZ_GCI_MAX_EXTENDED_COUNT + 1) * 4 - 1)
        End Sub
    End Structure
    '<-- VB.NET 2003 p

    Public Structure MAZ_GCI_INFORMATION_B
        Dim size As Integer            '// size of this structure
        Dim frequency As Single        '// frequency(MHz)
        '// vendor name
        <VBFixedString(MAZ_GCI_MAX_VNAME_LEN), MarshalAs(UnmanagedType.ByValTStr, SizeConst:=MAZ_GCI_MAX_VNAME_LEN + 1)> _
        Dim vendorName As String
        '// name of model
        <VBFixedString(MAZ_GCI_MAX_MNAME_LEN), MarshalAs(UnmanagedType.ByValTStr, SizeConst:=MAZ_GCI_MAX_MNAME_LEN + 1)> _
        Dim modelName As String
        Dim family As Integer          '// family of the processor
        Dim extendedFamily As Integer  '// extended family of the processor
        Dim baseFamily As Integer      '// base family of the processor
        Dim model As Integer           '// model of the processor
        Dim extendedModel As Integer   '// extended model of the processor
        Dim baseModel As Integer       '// base model of the processor
        Dim stepping As Integer        '// the processor revision number
        Dim cores As Integer           '// the processor count 
        Dim logicalCores As Integer    '// the logical processor count 
        Dim threads As Integer         '// Thread count
        Dim feature As Integer         '// the processor feature
        Sub initialize()
            size = 116
            vendorName = New String(Chr(Asc(" ")), MAZ_GCI_MAX_VNAME_LEN)
            modelName = New String(Chr(Asc(" ")), MAZ_GCI_MAX_MNAME_LEN)
        End Sub
    End Structure


    '//
    '//// k/L
    '//
    '//* mazCompress & mazExpand *//
    '// 
    Public Const MAZ_CMP_MODE As Integer = &HF
    Public Const MAZ_CMP_OPTION As Integer = &HFF0
    Public Const MAZ_CMP_MODE_4096 As Integer = &H2
    Public Const MAZ_CMP_MODE_8192 As Integer = &H3
    Public Const MAZ_CMP_MODE_16384 As Integer = &H4
    Public Const MAZ_CMP_MODE_32768 As Integer = &H5
    Public Const MAZ_CMP_MODE_65536 As Integer = &H6
    Public Const MAZ_CMP_OPTION_DIFF As Integer = &H10
    '// ^
    Public Structure MAZ_CMP_PACK_LZ
        Dim rules As Integer    '// k@
        Dim size As Integer     '// f[^TCY
        Dim cmpSize As Integer  '// kf[^TCY
        Dim cmpData As IntPtr   '// kf[^
    End Structure
    '//* mazDecordByHuffman & mazEncodeByHuffman *//
    '// ^
    Public Structure MAZ_CMP_PACK_HUFF
        Dim size As Integer     '// f[^TCY
        Dim cmpSize As Integer  '// kf[^TCY
        Dim freqSize As Integer '// opx\TCY
        Dim freq As IntPtr      '// opx\
        Dim cmpData As IntPtr   '// kf[^
    End Structure


    '//
    '//// /l ϊ
    '//
    '//* mazCDouble* & mazCSingle* *//
    Public Const MAZ_CDS_E As Integer = 0
    Public Const MAZ_CDS_F As Integer = 1
    Public Const MAZ_CDS_G As Integer = 2
    Public Const MAZ_CDS_A As Integer = 3


    '//
    '//// [
    '//
    '//* mazBitArray *//
    Public Const MAZ_BAR_GET_MEMORY As Integer = 1
    Public Const MAZ_BAR_SET_BIT As Integer = 2
    Public Const MAZ_BAR_RESET_BIT As Integer = 3
    Public Const MAZ_BAR_GET_BIT As Integer = 4
    Public Const MAZ_BAR_DELETE_PAGE As Integer = 5
    Public Const MAZ_BAR_DELETE_ALL_PAGE As Integer = 6
    '//* mazQueue *//
    '// 
    Public Const MAZ_QUE_TYPE As Integer = &HFF
    Public Const MAZ_QUE_COMMAND As Integer = &HFF00
    Public Const MAZ_QUE_COMMAND_NUMBER As Integer = &HE000
    Public Const MAZ_QUE_COMMAND_ONE As Integer = &H0

    Public Const MAZ_QUE_TYPE_INT32 As Integer = &H0
    Public Const MAZ_QUE_TYPE_INT16 As Integer = &H1
    Public Const MAZ_QUE_TYPE_INT64 As Integer = &H2
    Public Const MAZ_QUE_TYPE_BYTE As Integer = &H3
    Public Const MAZ_QUE_TYPE_FLOAT As Integer = &H4
    Public Const MAZ_QUE_TYPE_DOUBLE As Integer = &H5
    Public Const MAZ_QUE_TYPE_CONTAINER_A As Integer = &H6
    Public Const MAZ_QUE_TYPE_CONTAINER_B As Integer = &H7 '// new type
    Public Const MAZ_QUE_CMD_CREATE As Integer = &H0
    Public Const MAZ_QUE_CMD_DESTROY As Integer = &H100
    Public Const MAZ_QUE_CMD_POP As Integer = &H200
    Public Const MAZ_QUE_CMD_PUSH As Integer = &H300
    Public Const MAZ_QUE_CMD_PEEK As Integer = &H400
    Public Const MAZ_QUE_CMD_DELCONTAINER As Integer = &H500
    Public Const MAZ_QUE_CMD_GETCOUNT As Integer = &H600
    Public Const MAZ_QUE_CMD_CONTAINES As Integer = &H700
    Public Const MAZ_QUE_CMD_ENUMERATE_BEGINNING As Integer = &H800
    Public Const MAZ_QUE_CMD_ENUMERATE As Integer = &H900
    '// ߂l
    Public Const MAZ_QUE_ERR_MEMORY As Integer = -100
    Public Const MAZ_QUE_EMPTY As Integer = -3
    Public Const MAZ_QUE_FULL As Integer = -2
    Public Const MAZ_QUE_FAILURE As Integer = -1
    Public Const MAZ_QUE_CONTAINED As Integer = 1
    Public Const MAZ_QUE_NOT_CONTAINED As Integer = 2
    '// ^
    Public Structure MAZ_QUE_CREATE
        '// L[ / X^bN \z
        Dim valueType As Integer '// f[^^
        Dim depth As Integer     '// ő[
        Sub initialize()
            valueType = 0
            depth = 0
        End Sub
    End Structure

    Public Structure MAZ_STK1_CREATE
        '// L[ / X^bN \z
        Dim valueType As Integer    '// f[^^
        Dim depth As Integer        '// ő[
        Sub initialize()
            valueType = 0
            depth = 0
        End Sub
    End Structure

    Public Structure MAZ_STK2_CREATE
        '// L[ / X^bN \z
        Dim valueType As Integer  '// f[^^
        Dim depth As Integer      '// ő[
        Sub initialize()
            valueType = 0
            depth = 0
        End Sub
    End Structure

    Public Structure MAZ_QUE_QUEUE
        '// L[IuWFNg
        Dim depth As Integer       '// ő[
        Dim valueType As Integer   '// f[^^
        Dim queue As IntPtr        '// L[̃|C^
        Sub initialize()
            depth = 0
            valueType = 0
            queue = IntPtr.Zero
        End Sub
    End Structure

    Public Structure MAZ_QUE_CONTAINER_A
        '// f[^Rei
        Dim size As Integer           '// parameters ̃TCY
        Dim globalPointer As Integer  '// parameters ̓O[o
        Dim parameters As IntPtr
        Sub initialize()
            size = 0
            globalPointer = 0
            parameters = IntPtr.Zero
        End Sub
    End Structure

    Public Structure MAZ_QUE_CONTAINER_A_STRING
        '// f[^Rei
        Dim size As Integer            '// parameters ̃TCY
        Dim globalPointer As Integer   '// parameters ̓O[o
        Dim parameters As String
        Sub initialize()
            size = 0
            globalPointer = 0
            parameters = New String(CChar("\0"), 512)
        End Sub
    End Structure

    Public Structure MAZ_STK1_CONTAINER_A
        '// f[^Rei
        Dim size As Integer            '// parameters ̃TCY
        Dim globalPointer As Integer   '// parameters ̓O[o
        Dim parameters As IntPtr
        Sub initialize()
            size = 0
            globalPointer = 0
            parameters = IntPtr.Zero
        End Sub
    End Structure

    Public Structure MAZ_STK1_CONTAINER_A_STRING
        '// f[^Rei
        Dim size As Integer            '// parameters ̃TCY
        Dim globalPointer As Integer   '// parameters ̓O[o
        Dim parameters As String
        Sub initialize()
            size = 0
            globalPointer = 0
            parameters = New String(CChar("\0"), 512)
        End Sub
    End Structure

    Public Structure MAZ_QUE_CONTAINER_B
        '// f[^Rei
        Dim size As Integer '// parameters ̃TCY
        Dim parameters As IntPtr
        Sub initialize()
            size = 0
            parameters = IntPtr.Zero
        End Sub
    End Structure

    Public Structure MAZ_QUE_CONTAINER_B_STRING
        '// f[^Rei
        Dim size As Integer '// parameters ̃TCY
        Dim parameters As String
        Sub initialize()
            size = 0
            parameters = New String(CChar("\0"), 512)
        End Sub
    End Structure

    Public Structure MAZ_STK1_CONTAINER_B
        '// f[^Rei
        Dim size As Integer '// parameters ̃TCY
        Dim parameters As IntPtr
        Sub initialize()
            size = 0
            parameters = IntPtr.Zero
        End Sub
    End Structure

    Public Structure MAZ_STK1_CONTAINER_B_STRING
        '// f[^Rei
        Dim size As Integer '// parameters ̃TCY
        Dim parameters As String
        Sub initialize()
            size = 0
            parameters = New String(CChar("\0"), 512)
        End Sub
    End Structure

    Public Structure MAZ_STK2_CONTAINER
        '// f[^Rei
        Dim size As Integer '// parameters ̃TCY
        Dim parameters As IntPtr
        Sub initialize()
            size = 0
            parameters = IntPtr.Zero
        End Sub
    End Structure

    Public Structure MAZ_STK2_CONTAINER_STRING
        '// f[^Rei
        Dim size As Integer '// parameters ̃TCY
        Dim parameters As String
        Sub initialize()
            size = 0
            parameters = New String(CChar("\0"), 512)
        End Sub
    End Structure

    '//* mazStack *//
    '// 
    Public Const MAZ_STK1_TYPE As Integer = MAZ_QUE_TYPE
    Public Const MAZ_STK1_COMMAND As Integer = MAZ_QUE_COMMAND
    Public Const MAZ_STK1_COMMAND_NUMBER As Integer = MAZ_QUE_COMMAND_NUMBER
    Public Const MAZ_STK1_COMMAND_ONE As Integer = &H0

    Public Const MAZ_STK1_TYPE_INT32 As Integer = MAZ_QUE_TYPE_INT32
    Public Const MAZ_STK1_TYPE_INT16 As Integer = MAZ_QUE_TYPE_INT16
    Public Const MAZ_STK1_TYPE_INT64 As Integer = MAZ_QUE_TYPE_INT64
    Public Const MAZ_STK1_TYPE_BYTE As Integer = MAZ_QUE_TYPE_BYTE
    Public Const MAZ_STK1_TYPE_FLOAT As Integer = MAZ_QUE_TYPE_FLOAT
    Public Const MAZ_STK1_TYPE_DOUBLE As Integer = MAZ_QUE_TYPE_DOUBLE
    Public Const MAZ_STK1_TYPE_CONTAINER_A As Integer = MAZ_QUE_TYPE_CONTAINER_A
    Public Const MAZ_STK1_TYPE_CONTAINER_B As Integer = MAZ_QUE_TYPE_CONTAINER_B
    Public Const MAZ_STK1_CMD_CREATE As Integer = MAZ_QUE_CMD_CREATE
    Public Const MAZ_STK1_CMD_DESTROY As Integer = MAZ_QUE_CMD_DESTROY
    Public Const MAZ_STK1_CMD_POP As Integer = MAZ_QUE_CMD_POP
    Public Const MAZ_STK1_CMD_PUSH As Integer = MAZ_QUE_CMD_PUSH
    Public Const MAZ_STK1_CMD_PEEK As Integer = MAZ_QUE_CMD_PEEK
    Public Const MAZ_STK1_CMD_DELCONTAINER As Integer = MAZ_QUE_CMD_DELCONTAINER

    Public Const MAZ_STK2_TYPE As Integer = MAZ_QUE_TYPE
    Public Const MAZ_STK2_COMMAND As Integer = MAZ_QUE_COMMAND
    Public Const MAZ_STK2_COMMAND_NUMBER As Integer = MAZ_QUE_COMMAND_NUMBER
    Public Const MAZ_STK2_COMMAND_TWO As Integer = &H2000

    Public Const MAZ_STK2_TYPE_INT32 As Integer = MAZ_QUE_TYPE_INT32
    Public Const MAZ_STK2_TYPE_INT16 As Integer = MAZ_QUE_TYPE_INT16
    Public Const MAZ_STK2_TYPE_INT64 As Integer = MAZ_QUE_TYPE_INT64
    Public Const MAZ_STK2_TYPE_BYTE As Integer = MAZ_QUE_TYPE_BYTE
    Public Const MAZ_STK2_TYPE_FLOAT As Integer = MAZ_QUE_TYPE_FLOAT
    Public Const MAZ_STK2_TYPE_DOUBLE As Integer = MAZ_QUE_TYPE_DOUBLE
    Public Const MAZ_STK2_TYPE_CONTAINER As Integer = MAZ_QUE_TYPE_CONTAINER_B
    Public Const MAZ_STK2_CMD_CREATE As Integer = &H2000
    Public Const MAZ_STK2_CMD_DESTROY As Integer = &H2100
    Public Const MAZ_STK2_CMD_POP As Integer = &H2200
    Public Const MAZ_STK2_CMD_PUSH As Integer = &H2300
    Public Const MAZ_STK2_CMD_PEEK As Integer = &H2400
    Public Const MAZ_STK2_CMD_BACK As Integer = &H2500
    Public Const MAZ_STK2_CMD_ENUMERATE_BEGINNING As Integer = &H2600
    Public Const MAZ_STK2_CMD_ENUMERATE As Integer = &H2700
    '// ߂l
    Public Const MAZ_STK1_ERR_MEMORY As Integer = MAZ_QUE_ERR_MEMORY
    Public Const MAZ_STK1_FAILURE As Integer = MAZ_QUE_FAILURE
    Public Const MAZ_STK2_ERR_MEMORY As Integer = MAZ_QUE_ERR_MEMORY
    Public Const MAZ_STK2_FAILURE As Integer = MAZ_QUE_FAILURE

    Public Structure MAZ_STK1_STACK
        '// X^bNIuWFNg
        Dim depth As Integer        '// ő[
        Dim valueType As Integer    '// f[^^
        Dim stack As IntPtr         '// X^bÑ|C^
        Sub initialize()
            depth = 0
            valueType = 0
            stack = IntPtr.Zero
        End Sub
    End Structure

    Public Structure MAZ_STK2_STACK
        '// X^bNIuWFNg
        Dim depth As Integer        '// ő[
        Dim valueType As Integer    '// f[^^
        Dim stack As IntPtr         '// X^bÑ|C^
        Sub initialize()
            depth = 0
            valueType = 0
            stack = IntPtr.Zero
        End Sub
    End Structure

    '//
    '//// ̑
    '//
    '//* mazGetTime *//
    '// 
    Public Const MAZ_GTM_SYSTEM_TIME As Integer = &H0
    Public Const MAZ_GTM_LOCAL_TIME As Integer = &H1


    '//
    '//// ֐`
    '//

    '// fBXN
    Public Declare Function _
    mazCheckActiveDrive Lib "mmgic3az.dll" _
    (ByVal driveLetter As String) _
    As Integer

    Public Declare Function _
    mazGetDiskSize Lib "mmgic3az.dll" _
    (ByVal directoryName As String, ByRef freeSize As Long, ByRef totalSize As Long) _
    As Integer

    Public Declare Function _
    mazGetDriveType Lib "mmgic3az.dll" _
    (ByVal driveLetter As String) _
    As Integer

    Public Declare Function _
    mazGetLogicalDrives Lib "mmgic3az.dll" () _
    As Integer

    Public Declare Function _
    mazGetVolumeInformation Lib "mmgic3az.dll" _
    (ByVal rootPathName As String, ByRef volumeInformation As MAZ_GVI_VOLUME_INFORMATION) _
    As Integer

    '// t@C
    Public Declare Function _
    mazGetFileAttributes Lib "mmgic3az.dll" _
    (ByVal fileName As String, ByRef attributes As Integer) _
    As Integer

    Public Declare Function _
    mazGetFileSize Lib "mmgic3az.dll" _
    (ByVal fileName As String) _
    As Long

    Public Declare Function _
    mazGetFileTime Lib "mmgic3az.dll" _
    (ByVal functions As Integer, _
     ByVal fileName As String, _
     ByRef createTime As IntPtr, _
     ByRef accessTime As IntPtr, _
     ByRef writeTime As MAZ_SYSTEMTIME) _
    As Integer

    Public Declare Function _
    mazGetFileTime Lib "mmgic3az.dll" _
    (ByVal functions As Integer, _
     ByVal fileName As String, _
     ByRef createTime As IntPtr, _
     ByRef accessTime As MAZ_SYSTEMTIME, _
     ByRef writeTime As IntPtr) _
    As Integer

    Public Declare Function _
    mazGetFileTime Lib "mmgic3az.dll" _
    (ByVal functions As Integer, _
     ByVal fileName As String, _
     ByRef createTime As MAZ_SYSTEMTIME, _
     ByRef accessTime As IntPtr, _
     ByRef writeTime As IntPtr) _
    As Integer

    Public Declare Function _
    mazGetFileTime Lib "mmgic3az.dll" _
    (ByVal functions As Integer, _
     ByVal fileName As String, _
     ByRef createTime As MAZ_SYSTEMTIME, _
     ByRef accessTime As MAZ_SYSTEMTIME, _
     ByRef writeTime As MAZ_SYSTEMTIME) _
    As Integer

    Public Declare Function _
    mazGetFileVersion Lib "mmgic3az.dll" _
    (ByVal file As String, _
     ByRef major As Integer, _
     ByRef minor As Integer, _
     ByRef revision As Integer, _
     ByRef bild As Integer) _
    As Integer

    Public Declare Function _
    mazGetFileVersionEx Lib "mmgic3az.dll" _
    (ByVal fileName As String, ByVal size As Integer, ByRef version As MAZ_GFV_FILE_VERSION) _
    As Integer

    Public Declare Function _
    mazGetLongFileName Lib "mmgic3az.dll" _
    (ByVal shortName As String, ByVal longName As IntPtr) _
    As Integer

    Public Declare Function _
    mazGetLongFileName Lib "mmgic3az.dll" _
    (ByVal shortName As String, ByVal longName As StringBuilder) _
    As Integer

    Public Declare Function _
    mazGetShortFileName Lib "mmgic3az.dll" _
    (ByVal longName As String, ByVal shortName As IntPtr) _
    As Integer

    Public Declare Function _
    mazGetShortFileName Lib "mmgic3az.dll" _
    (ByVal longName As String, ByVal shortName As StringBuilder) _
    As Integer

    Public Declare Function _
    mazGetSpecialFolderPath Lib "mmgic3az.dll" _
    (ByVal pathName As StringBuilder, ByVal folder As Integer) _
    As Integer

    Public Declare Function _
    mazGetTempFileName Lib "mmgic3az.dll" _
    (ByVal fileName As StringBuilder) _
    As Integer

    Public Declare Function _
    mazGetWindowsPath Lib "mmgic3az.dll" _
    (ByVal functions As Integer, ByVal path As StringBuilder) _
    As Integer

    Public Declare Function _
    mazSearchDirectory Lib "mmgic3az.dll" _
    (ByVal parameters As Integer, _
     ByVal directory As String, _
     ByVal fileName As String, _
     ByVal listFile As IntPtr, _
     ByRef directorySearch As MAZ_SDR_DIRECTORY_SEARCH) _
    As Integer

    Public Declare Function _
    mazSearchDirectory Lib "mmgic3az.dll" _
    (ByVal parameters As Integer, _
     ByVal directory As String, _
     ByVal fileName As String, _
     ByVal listFile As IntPtr, _
     ByRef directorySearch As IntPtr) _
    As Integer

    Public Declare Function _
    mazSearchDirectory Lib "mmgic3az.dll" _
    (ByVal parameters As Integer, _
     ByVal directory As String, _
     ByVal fileName As String, _
     ByVal listFile As String, _
     ByRef directorySearch As MAZ_SDR_DIRECTORY_SEARCH) _
    As Integer

    Public Declare Function _
    mazSearchDirectory Lib "mmgic3az.dll" _
    (ByVal parameters As Integer, _
     ByVal directory As String, _
     ByVal fileName As String, _
     ByVal listFile As String, ByRef directorySearch As IntPtr) _
    As Integer

    Public Declare Function _
    mazSetFileAttributes Lib "mmgic3az.dll" _
    (ByVal fileName As String, ByVal attributes As Integer) _
    As Integer

    Public Declare Function _
    mazSetFileTime Lib "mmgic3az.dll" _
    (ByVal functions As Integer, _
     ByVal fileName As String, _
     ByRef createTime As IntPtr, _
     ByRef accessTime As IntPtr, _
     ByRef writeTime As MAZ_SYSTEMTIME) _
    As Integer

    Public Declare Function _
    mazSetFileTime Lib "mmgic3az.dll" _
    (ByVal functions As Integer, _
     ByVal fileName As String, _
     ByRef createTime As IntPtr, _
     ByRef accessTime As MAZ_SYSTEMTIME, _
     ByRef writeTime As IntPtr) _
    As Integer

    Public Declare Function _
    mazSetFileTime Lib "mmgic3az.dll" _
    (ByVal functions As Integer, _
     ByVal fileName As String, _
     ByRef createTime As MAZ_SYSTEMTIME, _
     ByRef accessTime As IntPtr, _
     ByRef writeTime As IntPtr) _
    As Integer

    Public Declare Function _
    mazSetFileTime Lib "mmgic3az.dll" _
    (ByVal functions As Integer, _
     ByVal fileName As String, _
     ByRef createTime As MAZ_SYSTEMTIME, _
     ByRef accessTime As MAZ_SYSTEMTIME, _
     ByRef writeTime As MAZ_SYSTEMTIME) _
    As Integer

    Public Declare Function _
    mazShowDirListBox Lib "mmgic3az.dll" _
    (ByRef info As MAZ_SDB_INFORMATION, ByVal directoryName As StringBuilder) _
    As Integer

    '// WXg
    Public Declare Function _
    mazGetRegData Lib "mmgic3az.dll" _
    (ByVal functions As Integer, _
     ByVal key As Integer, _
     ByVal subKey As String, _
     ByVal name As String, _
     ByVal type As Integer, _
     ByVal data As IntPtr, _
     ByRef size As Integer) _
    As Integer

    Public Declare Function _
    mazGetRegData Lib "mmgic3az.dll" _
    (ByVal functions As Integer, _
     ByVal key As Integer, _
     ByVal subKey As String, _
     ByVal name As String, _
     ByVal type As Integer, _
     ByVal data() As Byte, _
     ByRef size As Integer) _
    As Integer

    Public Declare Function _
    mazSetRegData Lib "mmgic3az.dll" _
    (ByVal key As Integer, _
     ByVal subKey As String, _
     ByVal name As String, _
     ByVal type As Integer, _
     ByVal data() As Byte, _
     ByVal size As Integer) _
    As Integer

    '// VXe
    Public Declare Function _
    mazGetComputerName Lib "mmgic3az.dll" _
    (ByVal computerName As StringBuilder) _
    As Integer

    Public Declare Function _
    mazGetCpuInformationsA Lib "mmgic3az.dll" _
    (ByRef informationsA As MAZ_GCI_INFORMATION_A, ByVal fileName As Integer) _
    As Integer

    Public Declare Function _
    mazGetCpuInformationsA Lib "mmgic3az.dll" _
    (ByRef informationsA As MAZ_GCI_INFORMATION_A, ByVal fileName As String) _
    As Integer

    Public Declare Function _
    mazGetCpuInformationsB Lib "mmgic3az.dll" _
    (ByVal time As Integer, ByRef informationsB As MAZ_GCI_INFORMATION_B) _
    As Integer

    Public Declare Function _
    mazGetLoginName Lib "mmgic3az.dll" _
    (ByVal loginName As StringBuilder) _
    As Integer

    Public Declare Function _
    mazGetMemoryStatusEx Lib "mmgic3az.dll" _
    (ByRef buffer As MAZ_MEMORYSTATUSEX) _
    As Integer

    Public Declare Function _
    mazGetWinVersion Lib "mmgic3az.dll" _
    (ByRef versionInfo As MAZ_GWV_OSVERSIONINFO) _
    As IntPtr

    '// k/L
    Public Declare Function _
    mazCompress Lib "mmgic3az.dll" _
    (ByVal data() _
    As Byte, ByRef cmpPack As MAZ_CMP_PACK_LZ) _
    As Integer

    Public Declare Function _
    mazDecodeByHuffman Lib "mmgic3az.dll" _
    (ByRef cmpPack As MAZ_CMP_PACK_HUFF, ByVal destination() _
    As Byte) _
    As Integer

    Public Declare Function _
    mazDecodeByWeyl Lib "mmgic3az.dll" _
    (ByVal source() As Byte, _
     ByVal original() As Integer, _
     ByVal originalSize As Integer) _
    As Integer

    Public Declare Function _
    mazDeleteCmpPack Lib "mmgic3az.dll" _
    (ByRef cmpPack As MAZ_CMP_PACK_LZ) _
    As IntPtr

    Public Declare Function _
    mazDeleteCmpPackHuffman Lib "mmgic3az.dll" _
    (ByRef cmpPack As MAZ_CMP_PACK_HUFF) _
    As IntPtr

    Public Declare Function _
    mazEncodeByHuffman Lib "mmgic3az.dll" _
    (ByVal source() As Byte, _
     ByRef cmpPack As MAZ_CMP_PACK_HUFF) _
    As Integer

    Public Declare Function _
    mazEncodeByWeyl Lib "mmgic3az.dll" _
    (ByVal source() As Integer, _
     ByVal destination() As Byte, _
     ByVal sourceSize As Integer, _
     ByVal destinationSize As Integer) _
    As Integer

    Public Declare Function _
    mazExpand Lib "mmgic3az.dll" _
    (ByRef cmpPack As MAZ_CMP_PACK_LZ, ByVal data() As Byte) _
    As Integer

    '// Z֐
    Public Declare Function _
    mazAddInt64 Lib "mmgic3az.dll" _
    (ByRef a As Long, ByRef b As Long) _
    As Long

    Public Declare Function _
    mazCompareInt64 Lib "mmgic3az.dll" _
    (ByRef a As Long, ByRef b As Long) _
    As Integer

    Public Declare Function _
    mazDivideInt64 Lib "mmgic3az.dll" _
    (ByRef a As Long, ByRef b As Long) _
    As Long

    Public Declare Function _
    mazMultiplyInt64 Lib "mmgic3az.dll" _
    (ByRef a As Long, ByRef b As Long) _
    As Long

    Public Declare Function _
    mazSetInt64 Lib "mmgic3az.dll" _
    (ByVal a As String) _
    As Long

    Public Declare Function _
    mazSubtractInt64 Lib "mmgic3az.dll" _
    (ByRef a As Long, ByRef b As Long) _
    As Long

    '// CRC
    Public Declare Function _
    mazGetCRC16 Lib "mmgic3az.dll" _
    (ByVal reset As Integer, ByVal n As Short, ByVal a As IntPtr) _
    As Short

    Public Declare Function _
    mazGetCRC16 Lib "mmgic3az.dll" _
    (ByVal reset As Integer, ByVal n As Short, ByVal a() As Byte) _
    As Short

    Public Declare Function _
    mazGetCRC16ofFile Lib "mmgic3az.dll" _
    (ByVal fileName As String) _
    As Short

    Public Declare Function _
    mazGetCRC32 Lib "mmgic3az.dll" _
    (ByVal reset As Integer, ByVal n As Integer, ByVal a As IntPtr) _
    As Integer

    Public Declare Function _
    mazGetCRC32 Lib "mmgic3az.dll" _
    (ByVal reset As Integer, ByVal n As Integer, ByVal a() As Byte) _
    As Integer

    Public Declare Function _
    mazGetCRC32ofFile Lib "mmgic3az.dll" _
    (ByVal fileName As String) _
    As Integer

    '// /l ϊ
    Public Declare Function _
    mazCByteToInt16 Lib "mmgic3az.dll" _
    (ByVal b() As Byte) _
    As Short

    Public Declare Function _
    mazCByteToInt32 Lib "mmgic3az.dll" _
    (ByVal b() As Byte) _
    As Integer

    Public Declare Function _
    mazCByteToInt64 Lib "mmgic3az.dll" _
    (ByVal b() As Byte) _
    As Long

    Public Declare Function _
    mazCByteToString Lib "mmgic3az.dll" _
    (ByVal b() As Byte, ByVal ip As IntPtr, ByVal size As Integer) _
    As Integer

    Public Declare Function _
    mazCByteToString Lib "mmgic3az.dll" _
    (ByVal b() As Byte, ByVal sb As StringBuilder, ByVal size As Integer) _
    As Integer

    Public Declare Function _
    mazCDoubleToInt16 Lib "mmgic3az.dll" _
    (ByVal d As Double) _
    As Short

    Public Declare Function _
    mazCDoubleToInt32 Lib "mmgic3az.dll" _
    (ByVal d As Double) _
    As Integer

    Public Declare Function _
    mazCDoubleToInt64 Lib "mmgic3az.dll" _
    (ByVal d As Double) _
    As Long

    Public Declare Function _
    mazCDoubleToString Lib "mmgic3az.dll" _
    (ByVal d As Double, ByVal type As Integer, ByVal sb As StringBuilder) _
    As IntPtr

    Public Declare Function _
    mazCInt16ToByte Lib "mmgic3az.dll" _
    (ByVal s As Short, ByVal b() As Byte) _
    As IntPtr

    Public Declare Function _
    mazCInt16ToString Lib "mmgic3az.dll" _
    (ByVal s As Short, ByVal radix As Integer, ByVal sb As StringBuilder) _
    As IntPtr

    Public Declare Function _
    mazCInt32ToByte Lib "mmgic3az.dll" _
    (ByVal i As Integer, ByVal b() As Byte) _
    As IntPtr

    Public Declare Function _
    mazCInt32ToString Lib "mmgic3az.dll" _
    (ByVal i As Integer, ByVal radix As Integer, ByVal sb As StringBuilder) _
    As IntPtr

    Public Declare Function _
    mazCInt64ToByte Lib "mmgic3az.dll" _
    (ByRef l As Long, ByVal b() As Byte) _
    As IntPtr

    Public Declare Function _
    mazCInt64ToString Lib "mmgic3az.dll" _
    (ByRef l As Long, ByVal radix As Integer, ByVal sb As StringBuilder) _
    As IntPtr

    Public Declare Function _
    mazCSingleToInt16 Lib "mmgic3az.dll" _
    (ByVal s As Single) _
    As Short

    Public Declare Function _
    mazCSingleToInt32 Lib "mmgic3az.dll" _
    (ByVal s As Single) _
    As Integer

    Public Declare Function _
    mazCSingleToInt64 Lib "mmgic3az.dll" _
    (ByVal s As Single) _
    As Long

    Public Declare Function _
    mazCSingleToString Lib "mmgic3az.dll" _
    (ByVal s As Single, ByVal type As Integer, ByVal sb As StringBuilder) _
    As IntPtr

    Public Declare Function _
    mazCStringToByte Lib "mmgic3az.dll" _
    (ByVal sb As StringBuilder, ByVal ip As IntPtr, ByVal size As Integer) _
    As Integer

    Public Declare Function _
    mazCStringToByte Lib "mmgic3az.dll" _
    (ByVal sb As StringBuilder, ByVal b() As Byte, ByVal size As Integer) _
    As Integer

    Public Declare Function _
    mazStringLower Lib "mmgic3az.dll" _
    (ByVal sb As StringBuilder) _
    As IntPtr

    Public Declare Function _
    mazStringUpper Lib "mmgic3az.dll" _
    (ByVal sb As StringBuilder) _
    As IntPtr

    '// lf[^
    Public Declare Function _
    mazRand0d Lib "mmgic3az.dll" _
    () _
    As Double

    Public Declare Function _
    mazRand0i Lib "mmgic3az.dll" _
    () _
    As Integer

    Public Declare Function _
    mazSetSeed Lib "mmgic3az.dll" _
    (ByVal seed As Integer) _
    As IntPtr

    Public Declare Function _
    mazShiftByteL Lib "mmgic3az.dll" _
    (ByVal a As Byte, ByVal shift As Integer) _
    As Byte

    Public Declare Function _
    mazShiftByteR Lib "mmgic3az.dll" _
    (ByVal a As Byte, ByVal shift As Integer) _
    As Byte

    Public Declare Function _
    mazShiftInt16L Lib "mmgic3az.dll" _
    (ByVal a As Short, ByVal shift As Integer) _
    As Short

    Public Declare Function _
    mazShiftInt16R Lib "mmgic3az.dll" _
    (ByVal a As Short, ByVal shift As Integer) _
    As Short

    Public Declare Function _
    mazShiftInt32L Lib "mmgic3az.dll" _
    (ByVal a As Integer, ByVal shift As Integer) _
    As Integer

    Public Declare Function _
    mazShiftInt32R Lib "mmgic3az.dll" _
    (ByVal a As Integer, ByVal shift As Integer) _
    As Integer

    Public Declare Function _
    mazShiftInt64L Lib "mmgic3az.dll" _
    (ByRef a As Long, ByVal shift As Integer) _
    As Long

    Public Declare Function _
    mazShiftInt64R Lib "mmgic3az.dll" _
    (ByRef a As Long, ByVal shift As Integer) _
    As Long

    '// [
    Public Declare Function _
    mazBitArray Lib "mmgic3az.dll" _
    (ByVal command As Integer, ByVal x As Integer, ByVal y As Integer, ByRef page As Integer) _
    As Integer

    Public Declare Function _
    mazBitArray Lib "mmgic3az.dll" _
    (ByVal command As Integer, ByVal x As Integer, ByVal y As Integer, ByVal page As IntPtr) _
    As Integer

    Public Declare Function _
    mazCopyMemory Lib "mmgic3az.dll" _
    (ByVal destination() As Integer, ByVal source() As Integer, ByVal size As Integer) _
    As IntPtr

    Public Declare Function _
    mazCopyMemory Lib "mmgic3az.dll" _
    (ByVal destination() As Long, ByVal source() As Long, ByVal size As Integer) _
    As IntPtr

    Public Declare Function _
    mazCopyMemory Lib "mmgic3az.dll" _
    (ByVal destination() As Short, ByVal source() As Short, ByVal size As Integer) _
    As IntPtr

    Public Declare Function _
    mazFillMemory Lib "mmgic3az.dll" _
    (ByVal destination() As Integer, ByVal fill As Byte, ByVal size As Integer) _
    As IntPtr

    Public Declare Function _
    mazFillMemory Lib "mmgic3az.dll" _
    (ByVal destination() As Long, ByVal fill As Byte, ByVal size As Integer) _
    As IntPtr

    Public Declare Function _
    mazFillMemory Lib "mmgic3az.dll" _
    (ByVal destination() As Short, ByVal fill As Byte, ByVal size As Integer) _
    As IntPtr

    Public Declare Function _
    mazGlobalCopy Lib "mmgic3az.dll" _
    (ByVal destination As StringBuilder, ByVal hSource As IntPtr, ByVal size As Integer) _
    As Integer

    Public Declare Function _
    mazQueue Lib "mmgic3az.dll" _
    (ByVal functions As Integer, ByRef queue As MAZ_QUE_QUEUE, ByVal value As IntPtr) _
    As Integer

    Public Declare Function _
    mazQueue Lib "mmgic3az.dll" _
    (ByVal functions As Integer, ByRef queue As MAZ_QUE_QUEUE, ByRef value As Short) _
    As Integer

    Public Declare Function _
    mazQueue Lib "mmgic3az.dll" _
    (ByVal functions As Integer, ByRef queue As MAZ_QUE_QUEUE, ByRef value As Integer) _
    As Integer

    Public Declare Function _
    mazQueue Lib "mmgic3az.dll" _
    (ByVal functions As Integer, ByRef queue As MAZ_QUE_QUEUE, ByRef value As Long) _
    As Integer

    Public Declare Function _
    mazQueue Lib "mmgic3az.dll" _
    (ByVal functions As Integer, ByRef queue As MAZ_QUE_QUEUE, ByRef value As Single) _
    As Integer

    Public Declare Function _
    mazQueue Lib "mmgic3az.dll" _
    (ByVal functions As Integer, ByRef queue As MAZ_QUE_QUEUE, ByRef value As Double) _
    As Integer

    Public Declare Function _
    mazQueue Lib "mmgic3az.dll" _
    (ByVal functions As Integer, ByRef queue As MAZ_QUE_QUEUE, ByRef value As MAZ_QUE_CONTAINER_A) _
    As Integer

    Public Declare Function _
    mazQueue Lib "mmgic3az.dll" _
    (ByVal functions As Integer, ByRef queue As MAZ_QUE_QUEUE, ByRef value As MAZ_QUE_CONTAINER_A_STRING) _
    As Integer

    Public Declare Function _
    mazQueue Lib "mmgic3az.dll" _
    (ByVal functions As Integer, ByRef queue As MAZ_QUE_QUEUE, ByRef value As MAZ_QUE_CONTAINER_B) _
    As Integer

    Public Declare Function _
    mazQueue Lib "mmgic3az.dll" _
    (ByVal functions As Integer, ByRef queue As MAZ_QUE_QUEUE, ByRef value As MAZ_QUE_CONTAINER_B_STRING) _
    As Integer

    Public Declare Function _
    mazQueue Lib "mmgic3az.dll" _
    (ByVal functions As Integer, ByRef queue As MAZ_QUE_QUEUE, ByRef value As MAZ_QUE_CREATE) _
    As Integer

    Public Declare Function _
    mazStack Lib "mmgic3az.dll" _
    (ByVal functions As Integer, ByRef stack As MAZ_STK1_STACK, ByVal value As IntPtr) _
    As Integer

    Public Declare Function _
    mazStack Lib "mmgic3az.dll" _
    (ByVal functions As Integer, ByRef stack As MAZ_STK1_STACK, ByRef value As Short) _
    As Integer

    Public Declare Function _
    mazStack Lib "mmgic3az.dll" _
    (ByVal functions As Integer, ByRef stack As MAZ_STK1_STACK, ByRef value As Integer) _
    As Integer

    Public Declare Function _
    mazStack Lib "mmgic3az.dll" _
    (ByVal functions As Integer, ByRef stack As MAZ_STK1_STACK, ByRef value As Long) _
    As Integer

    Public Declare Function _
    mazStack Lib "mmgic3az.dll" _
    (ByVal functions As Integer, ByRef stack As MAZ_STK1_STACK, ByRef value As Single) _
    As Integer

    Public Declare Function _
    mazStack Lib "mmgic3az.dll" _
    (ByVal functions As Integer, ByRef stack As MAZ_STK1_STACK, ByRef value As Double) _
    As Integer

    Public Declare Function _
    mazStack Lib "mmgic3az.dll" _
    (ByVal functions As Integer, ByRef stack As MAZ_STK1_STACK, ByRef value As MAZ_STK1_CONTAINER_A) _
    As Integer

    Public Declare Function _
    mazStack Lib "mmgic3az.dll" _
    (ByVal functions As Integer, ByRef stack As MAZ_STK1_STACK, ByRef value As MAZ_STK1_CONTAINER_A_STRING) _
    As Integer

    Public Declare Function _
    mazStack Lib "mmgic3az.dll" _
    (ByVal functions As Integer, ByRef stack As MAZ_STK1_STACK, ByRef value As MAZ_STK1_CONTAINER_B) _
    As Integer

    Public Declare Function _
    mazStack Lib "mmgic3az.dll" _
    (ByVal functions As Integer, ByRef stack As MAZ_STK1_STACK, ByRef value As MAZ_STK1_CONTAINER_B_STRING) _
    As Integer

    Public Declare Function _
    mazStack Lib "mmgic3az.dll" _
    (ByVal functions As Integer, ByRef stack As MAZ_STK1_STACK, ByRef value As MAZ_STK1_CREATE) _
    As Integer

    Public Declare Function _
    mazStack Lib "mmgic3az.dll" _
    (ByVal functions As Integer, ByRef stack As MAZ_STK2_STACK, ByVal value As IntPtr) _
    As Integer

    Public Declare Function _
    mazStack Lib "mmgic3az.dll" _
    (ByVal functions As Integer, ByRef stack As MAZ_STK2_STACK, ByRef value As Short) _
    As Integer

    Public Declare Function _
    mazStack Lib "mmgic3az.dll" _
    (ByVal functions As Integer, ByRef stack As MAZ_STK2_STACK, ByRef value As Integer) _
    As Integer

    Public Declare Function _
    mazStack Lib "mmgic3az.dll" _
    (ByVal functions As Integer, ByRef stack As MAZ_STK2_STACK, ByRef value As Long) _
    As Integer

    Public Declare Function _
    mazStack Lib "mmgic3az.dll" _
    (ByVal functions As Integer, ByRef stack As MAZ_STK2_STACK, ByRef value As Single) _
    As Integer

    Public Declare Function _
    mazStack Lib "mmgic3az.dll" _
    (ByVal functions As Integer, ByRef stack As MAZ_STK2_STACK, ByRef value As Double) _
    As Integer

    Public Declare Function _
    mazStack Lib "mmgic3az.dll" _
    (ByVal functions As Integer, ByRef stack As MAZ_STK2_STACK, ByRef value As MAZ_STK2_CONTAINER) _
    As Integer

    Public Declare Function _
    mazStack Lib "mmgic3az.dll" _
    (ByVal functions As Integer, ByRef stack As MAZ_STK2_STACK, ByRef value As MAZ_STK2_CONTAINER_STRING) _
    As Integer

    Public Declare Function _
    mazStack Lib "mmgic3az.dll" _
    (ByVal functions As Integer, ByRef stack As MAZ_STK2_STACK, ByRef value As MAZ_STK2_CREATE) _
    As Integer

    '// ̑
    Public Declare Function _
    mazCaptureButton Lib "mmgic3az.dll" _
    (ByRef wnd As IntPtr) _
    As Integer

    Public Declare Function _
    mazGetClient Lib "mmgic3az.dll" _
    (ByVal HWND As IntPtr, ByRef client As MAZ_RECT) _
    As IntPtr

    Public Declare Function _
    mazGetTime Lib "mmgic3az.dll" _
    (ByRef time As MAZ_SYSTEMTIME, ByVal time As Integer) _
    As IntPtr

    Public Declare Function _
    mazGetWorkArea Lib "mmgic3az.dll" _
    (ByRef workArea As MAZ_RECT, ByVal reserved As Integer) _
    As Integer

    '// R[obN֐
    Public Delegate Function _
    DirectorySearchAZ _
    (ByVal number As Integer, _
     ByVal fileName As String, _
     ByVal attributes As Integer, _
     ByVal parameters As SDR_FREE_PARAMETERS) _
    As Integer

End Module
