﻿//
//	コールバック関数 
//		mmgic3az.dll の mazSearchDirectory 関数を実行したとき 中から IamSearching 関数が呼び出さる。
//		引数は、変えられない。
//		IamSearching 関数の名前は、変えられる。
//		IamSearching 関数の中は、自由に書き換えられる。
//		SDR_FREE_PARAMETERS 構造体の変数は自由に増減できる。
//     ダイアログは自由に作れます。
//
using System;

namespace m3az
{
    class DirectorySearch
    {
        public static TestAZ.Form2 m_dialog;

        public struct SDR_FREE_PARAMETERS
        {
	        public string text;
        }
        
        public static int IamSearching( int     number, 
                                        string  fileName,
                                        uint    attributes, 
                                        SDR_FREE_PARAMETERS freeParameters)
        {
            //
            //	ファイル処理用コールバック関数
            //		この関数が TRUE を返すと処理続行、FALSE を返すと処理を中止する。
            int r;


            switch (number)
            {
                case maz.SDR_BEGINE_PROCESS:
                case maz.SDR_END_PROCESS:
                    r = maz.TRUE;
                    break;
                default:
                    m_dialog.SetDlgItem1(freeParameters.text, fileName);
                    // キャンセルボタンが押されたことをサーチする。FALSE を返すと処理を中止する。
                    r = maz.mazCaptureButton(m_dialog.Button1.Handle);
                    break;
            }

            return r;
        }
    }
}
